#! /usr/bin/env python
# -*- coding: utf-8 -*-
# TIME OF CREATION Wed Mar 24 12:22:46 2010
# ВРЕМЯ СОЗДАНИЯ Wed Mar 24 12:22:46 2010


class Braun:
	'''
		Метод Брауна
		
		Написан по алгоритму в методичке
		В общем полнейшая фигня, и похоже что это антипетерн
	'''
	
	def __init__(self, plus = 5, iter = 3, table=None, tex_mode = False):
	
		self.table = table
		self.to_positive(plus)
		self.tex_mode = tex_mode;
		
		self.first_i = 0
		self.rows = len(self.table)
		self.rows_xrange = xrange(self.rows)
		self.cols = len(self.table[0])
		self.cols_xrange = xrange(self.cols)
		
		self.iter(iter)
		
	def to_positive(self, number):
		'''
			Увеличивает матрицу на положительное число
		'''
		
		for list in self.table:
			for i in xrange(len(list)):
				list[i] += number
		
	def iter(self, number):
		'''
			Выполняет расчет
		'''
		
		def tex(list, index, string):
			'''
				Печатает полустроку таблицы в \TeX формате
			'''

			str = ""
			for j in xrange(len(list)):
				if(index == j):
					str +="\\%s{%s} & "%(string, list[j])	
				else:
					str +="%s & "%(list[j])
			return str

		counter = 1
		i = self.first_i
		
		b_list = None;
		a_list = None;
		b_list_old = [0 for x in self.table[i] ] 
		a_list_old = [0 for x in self.table ] 
		
		while(counter < number + 1):
			# на каждой итерации
			b_list = self.table[i][:]
				# берем данные из таблицы
			for x in self.cols_xrange:
				b_list[x] += b_list_old[x]
					# суммируем с предыдущим результатом 
			b_list_old = b_list[:]
				# перезаписываем предыдущий результат
			
			b_min = min(b_list)
			b_min_index = b_list.index(b_min)
			
			a_list = [self.table[x][b_min_index] for x in self.rows_xrange ] 
			for x in self.rows_xrange:
				a_list[x] += a_list_old[x]
			a_list_old = a_list[:]
			
			a_max = max(a_list)
			a_max_index = a_list.index(a_max)
			
			i = a_max_index
			
			v_min = 1.0 * b_min / counter
			v_max = 1.0 * a_max / counter
			v = (v_min + v_max) /2.0
					
			if not self.tex_mode :
				print counter, ':', i+1, b_list, b_min_index + 1, a_list, 'v = ', v, '<--', v_min, v_max
			else:
				print "\t%s &"%counter
				print "\t\t%s &"%(i+1)
				print "\t\t\t%s"%tex(b_list, b_min_index, 'underline')
				print "\t\t%s &"%(b_min_index + 1)
				print "\t\t\t%s"%tex(a_list, a_max_index, 'overline')
				print "\t\t%.4f &"%(v_min)
				print "\t\t%.4f &"%(v_max)
				print "\t\t%.4f \\\\"%(v)
				print "\t\t\\hline"

			counter += 1


def test():
	text_table = [
		[1, -1, 1, -2, 2, 0, 2, -2], 
		[-2, 1, 0, 1, -4, 2, 0, 2]
	]
	
	b = Braun(plus = 5, iter = 9, table = text_table, tex_mode = True);	

	
def main():
	pass;

if(__name__ == "__main__"):
	test();
	main();

