#! /usr/bin/env python
# -*- coding: utf-8 -*-
# TIME OF CREATION Wed Mar 24 12:22:46 2010
# ВРЕМЯ СОЗДАНИЯ Wed Mar 24 12:22:46 2010


import config
import numpy

_input = config.input

def transpose(a_matrix):
	m = numpy.matrix(a_matrix)
	return m.transpose().tolist()


def maxmin(matrix):
	mins = []
	for row in matrix:
		mins.append(min(row))
	return max(mins)
	

def minmax(matrix):
	n_matrix = transpose(matrix);
	maxs = []
	for row in n_matrix:
		maxs.append(max(row))
	return min(maxs)

##############################################################################################################
###
### Коалиционные игры 1x3
###
##############################################################################################################

#######################################################
###
### I против II, III, IV
###

def game_table_I_a_II_III_IV():	
	'''
		Возвращает таблицу для I против II, III, IV
	'''
	
	table = []
	for i1  in (1, 2):
		row = []
		for i2  in (1, 2):
			for i3  in (1, 2):
				for i4  in (1, 2):
					row.append( _input["%s%s%s%s"%(i1, i2, i3, i4)][0]  )
		table.append(row)
	return table;

			

#######################################################
###
### II против I, III, IV
###

	
def game_table_II_a_I_III_IV():	
	'''
		Возвращает таблицу для II против I, III, IV
	'''
	
	table = []
	for i2  in (1, 2):
		row = []
		for i1  in (1, 2):
			for i3  in (1, 2):
				for i4  in (1, 2):
					row.append( _input["%s%s%s%s"%(i1, i2, i3, i4)][1]  )
		table.append(row)
	return table


#######################################################
###
### III против I, II, IV
###
	
def game_table_III_a_I_II_IV():	
	'''
		Возвращает таблицу для III против I, II, IV
	'''
	
	table = []
	for i3  in (1, 2):
		row = []
		for i1  in (1, 2):
			for i2  in (1, 2):
				for i4  in (1, 2):
					row.append( _input["%s%s%s%s"%(i1, i2, i3, i4)][2]  )
		table.append(row)
	return table


#######################################################
###
### IV против I, II, III
###
	
def game_table_IV_a_I_II_III():	
	'''
		Возвращает таблицу для IV против I, II, III
	'''
	
	table = []
	for i4  in (1, 2):
		row = []
		for i1  in (1, 2):
			for i2  in (1, 2):
				for i3  in (1, 2):
					row.append( _input["%s%s%s%s"%(i1, i2, i3, i4)][3]  )
		table.append(row)
	return table

##############################################################################################################
###
### Коалиционные игры 2x2
###
##############################################################################################################

#######################################################
###
### I, II против III, IV
###

def game_table_I_II_a_III_IV():
	table = []
	for i1  in (1, 2):
		for i2  in (1, 2):
			row = []
			for i3  in (1, 2):
				for i4  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][0]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1]
					row.append(sum_1 + sum_2) 
			table.append( row )
	return table

		
#######################################################
###
### I, III против II, IV
###

def game_table_I_III_a_II_IV():
	table = []
	for i1  in (1, 2):
		for i3  in (1, 2):
			row = []
			for i2  in (1, 2):
				for i4  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1-1]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][3-1]
					row.append(sum_1 + sum_2) 
			table.append( row )
	return table
	
	
	
	
#######################################################
###
### I, IV против II, III
###

def game_table_I_IV_a_II_III():
	table = []
	for i1  in (1, 2):
		for i4  in (1, 2):
			row = []
			for i2  in (1, 2):
				for i3  in (1, 2):
					sum_1 = _input["%s%s%s%s"%(i1, i2, i3, i4)][1-1]
					sum_2 = _input["%s%s%s%s"%(i1, i2, i3, i4)][4-1]
					row.append(sum_1 + sum_2) 
			table.append( row )
	return table
	
'''	
print  maxmin(game_table_I_a_II_III_IV()), minmax(game_table_I_a_II_III_IV())
print  maxmin(game_table_II_a_I_III_IV()), minmax(game_table_II_a_I_III_IV())
print  maxmin(game_table_III_a_I_II_IV()), minmax(game_table_III_a_I_II_IV())
print  maxmin(game_table_IV_a_I_II_III()), minmax(game_table_IV_a_I_II_III())
print
print  maxmin(game_table_I_II_a_III_IV()), minmax(game_table_I_II_a_III_IV())
print  maxmin(game_table_I_III_a_II_IV()), minmax(game_table_I_III_a_II_IV())
print  maxmin(game_table_I_IV_a_II_III()), minmax(game_table_I_IV_a_II_III())

'''

print
print

#print game_table_I_II_a_III_IV()
#print game_table_I_III_a_II_IV()
#print game_table_I_IV_a_II_III()

#print game_table_I_a_II_III_IV()
#print game_table_II_a_I_III_IV()
#print game_table_III_a_I_II_IV()
#print game_table_IV_a_I_II_III()


##############################################################################################################
###
### Метод Брауна
###
##############################################################################################################

class Braun:
	def __init__(self, plus = 5, iter = 3, a_table=None):
		self.table = game_table_III_a_I_II_IV()
		#if(None != a_table):
		#	self.table = table
		self.to_positive(plus)
		
		self.first_i = 0
		self.rows = len(self.table)
		self.rows_xrange = xrange(self.rows)
		self.cols = len(self.table[0])
		self.cols_xrange = xrange(self.cols)
		
		self.iter(iter)
		
	def to_positive(self, number):
		for list in self.table:
			for i in xrange(len(list)):
				list[i] += number
		
	def iter(self, number):
		def tex(list):
			str = "| "
			for x in list:
				str +="%s & "%x 
			return str + "|"
			
		def tex2(list, index, string):
			str = ""
			for j in xrange(len(list)):
				if(index == j):
					str +="\\%s{%s} & "%(string, list[j])	
				else:
					str +="%s & "%(list[j])
			return str

			
		counter = 1
		i = self.first_i
		
		b_list = None;
		a_list = None;
		b_list_old = [0 for x in self.table[i] ] 
		a_list_old = [0 for x in self.table ] 
		
		while(counter < number + 1):
			# на каждой итерации
			b_list = self.table[i][:]
				# берем данные из таблицы
			for x in self.cols_xrange:
				b_list[x] += b_list_old[x]
					# суммируем с предыдущим результатом 
			b_list_old = b_list[:]
				# перезаписываем предыдущий результат
			
			b_min = min(b_list)
			b_min_index = b_list.index(b_min)
			
			a_list = [self.table[x][b_min_index] for x in self.rows_xrange ] 
			for x in self.rows_xrange:
				a_list[x] += a_list_old[x]
			a_list_old = a_list[:]
			
			a_max = max(a_list)
			a_max_index = a_list.index(a_max)
			
			i = a_max_index
			
			v_min = 1.0 * b_min / counter
			v_max = 1.0 * a_max / counter
			v = (v_min + v_max) /2.0
					
			if 0 == _FOR_TEX_ :
				print counter, ':', i+1, b_list, b_min_index + 1, a_list, 'v = ', v, '<--', v_min, v_max
			
				#print counter, ':', i+1, tex(b_list) , b_min_index + 1, tex(a_list), 'v = ', v, '<--', v_min, v_max 
			else:
				print "\t%s &"%counter
				print "\t\t%s &"%(i+1)
				print "\t\t\t%s"%tex2(b_list, b_min_index, 'underline')
				print "\t\t%s &"%(b_min_index + 1)
				print "\t\t\t%s"%tex2(a_list, a_max_index, 'overline')
				print "\t\t%.4f &"%(v_min)
				print "\t\t%.4f &"%(v_max)
				print "\t\t%.4f \\\\"%(v)
				print "\t\t\\hline"
			
			
			counter += 1
		
_FOR_TEX_ = 1
	
# b = Braun(plus = 5, iter = 9);

print game_table_III_a_I_II_IV()


########################################################
'''

inv = numpy.linalg.inv
simple_matrix = numpy.matrix(simple_matrix_list)

print inv(simple_matrix)
'''

#from sympy.matrices import *
#from sympy import pprint
#import sys
#sys.displayhook = pprint

#simple_matrix_list = 
[
	[	3 , 7 , 0 , 0 ],
	[	5 , 4 , 0 , 0 ],
	[	1 , 9 , 1 , 0 ],
	[	3 , 3 , 0 , 1 ],
]
#Cb = [[1,1,0,0]]

#P = Matrix(simple_matrix_list)
#Cb = Matrix(Cb)


#print P.inv()
#print Cb*P.inv()

#print 23/5 - 